\ display.f - Display driver                    22 Jan 2000  tcn

\ TBD:
\ "SCREEN" DATA STRUCTURE: (SCREEN uvar points to it)
\      (could also be serial, TCP stream, etc...)
\   1  bitmask: Capabilities of "screen" device
\   1  ATTR - video attribute (color)
\   2  CURSOR position
\   4  TXTBUF - memory-mapped character buffer
\  text screen size...?
\   4  VIDBUF - video framebuffer (ptr to BITMAP structure!)




DECIMAL

4 0ALIGN,  0 db,
LABEL: (ATTR)  7 db,
LABEL: XY  0 dw,
LABEL: TXTBUF  $B8000 dc,











LABEL: (SCROLL)
\ TBD: don't hardcode screen size to 80x25; use UVARS
  80 50 * #  W-PTR XY #@  CMP,
  <, NOT, IF,  ( need to scroll)
    ECX PUSH,  EAX PUSH,
\ TBD: copy top line to scrollback buffer
    ( Delete top line & move rest up)
    D-PTR TXTBUF #@ EDI MOV,  EDI ESI MOV,  160 # ESI ADD,
    80 25 * 2/ #  ECX MOV,  CLD,  D-PTR REP MOVS,
    ( Clear bottom line)
    (ATTR) #@ AH MOV, AL AL XOR, 80 # ECX MOV, W-PTR REP STOS,
    160 #  W-PTR XY #@  SUB,  ( adjust cursor pos.)
    EAX POP,  ECX POP,
  THEN,  RET,


LABEL: >XY
  ( Index port: 3D4  Data port: 3D5 )
  EAX push,
  $0F # AL MOV,  $3D4 # DX MOV,  AL OUT,  ( index: low byte)
  W-PTR XY #@ AX MOV,  1 # AX SHR,  EDX INC,  AL OUT,
  $0E # AL MOV,  EDX DEC,  AL OUT,     ( index: high byte)
  AH AL MOV,  EDX INC,  AL OUT,
  EAX pop,  RET,








LABEL: .NULL ( null - do nothing)
  RET,

LABEL: .BS  ( backspace)
\ TBD: Don't go past top of screen
  W-PTR 2 # XY #@ SUB,  \ backup 1 space
  W-PTR XY #@ EDI MOVZX,
  D-PTR TXTBUF #@ EDI ADD,
  AL AL XOR,  STOS,
  >XY # CALL,
  RET,

LABEL: .TAB
  D-PTR XY #@ INC,
  15 # XY #@ OR,
  D-PTR XY #@ INC,
  (SCROLL) # CALL,
  >XY # CALL,
  RET,

LABEL: .CR
  XY #@ AX MOV,
  160 ( # of columns x2) # CX MOV,
  DX DX XOR,  CX DIV,  DX CX SUB,
  CX XY #@ ADD,
  (SCROLL) # CALL,
  >XY # CALL,
  RET,

\ Jump table for EMIT
DECIMAL
LABEL: .chars  0 db,     8 db,   9 db,    10 db,
LABEL: .calls  .NULL dc, .BS dc, .TAB dc, .CR dc,
.calls .chars - CONSTANT .count

TCODE: emit ( char -)
  ECX PUSH,
  .count # ECX MOV,
  .chars # EDI MOV,  CLD,  REPNE SCAS,  \ search for char
  0=, IF,  \ special char:
    ECX NEG,
    .count } 1- { # ECX ADD,     \ get index into table
    .calls #@ ECX+ 4x CALL,  \ call via jump table
  ELSE,  \ regular char - just print it:
    (ATTR) #@ AH MOV,
    W-PTR XY #@ EDI MOVZX,
    D-PTR TXTBUF #@ EDI ADD,
    W-PTR STOS,  W-PTR 2 # XY #@ ADD,
    (SCROLL) # CALL,
    >XY # CALL,
  THEN,
  DROP,  ECX POP,  ;TCODE

TCODE: attr ( n -  Set the video attribute [color] )
  AL (ATTR) #@ MOV,  DROP,  ;TCODE

tCODE: page ( clear screen to current attr)
  eax push, ecx push, edi push,
  txtbuf #@ edi mov,                      \ Screen location
  (attr) #@ ah mov, al al xor,            \ Color attribute
  80 25 2 * * # ecx mov, W-PTR REP STOS,  \ Clear screen!
  0 # W-PTR XY #@ mov, >XY # call,        \ Reset cursor
  edi pop, ecx pop, eax pop,
  ;tCODE


