\ final.f - Final initialization                     tcn 02Jul00

\ Arrive here from init.f
  $ jump32: dc!
  ."    P-mode entry at " $.

HEX  \ Kernel initialization:
  10 # AX MOV,
  AX DS MOV,  AX ES MOV,  AX FS MOV,  AX GS MOV,  AX SS MOV,

  3F000 # ESP MOV,  \ Return stack
  40000 # EBP MOV,  \ Data stack

( DEBUG: print red '*')  W-PTR '* C00 + #  B8000 #@ MOV,


\ Initialize interrupts:
  4 INVERT # AL MOV,  \ Enable IRQ2 (cascade), disable the rest
  21 # AL OUT,  FF AL MOV,  A1 # AL OUT,  STI,

DECIMAL
 (:)
  \ Initialize drivers
  KBD-INIT

  \ Welcome message
  9 FOR cr NEXT
  $04 attr ." RETRO Native Forth" cr
  $07 attr

  \ Interpreter
  CForth
 (;)

  ."    final 'hang' at " $.
  hang

\ Set some target variables:
\ Note: add 5 to skip past code field, which is CALL DOVAR
lastxt @ { DICT }  5 +  t!
$ { H }  5 +  t!


\ Finalize the kernel image:
  DECIMAL
  $' 1024 -
  ." Kernel is " DUP . ." bytes (" $10000 OVER - . ." free) "
  512 /MOD SWAP 0<> 1 AND +
  ." in " DUP . ." sectors" cr
  #sec' db!  ( Set the "kernel size" in the boot sector)

  cr ." Final stack trace (should be empty):" cr
  .s cr

  save-buffers
  bye




