\ retro.f - Top level "load block"                   tcn 02jul00

  INCLUDE asm.f   \ Assembler

  USE image       \ Output blockfile (gforth-specific)
  1 ASM-BLOCK     \ Initialize assembler

\  INCLUDE uvars.f \ User variables
\ Memory map
HEX
  600 constant IDT
  E00 constant GDT
 1000 constant KEYTBL   \ Keys-down table
 1100 constant KEYBUF   \ Keystroke buffer


\ Boot Sequence:
\  1. loader.f   Boot sector - Loads RETRO from disk
\  2. init.f     80386 Protected Mode initialization
\  3. final.f    Arrive here from init.f and start up

  $7C00 ORG
  INCLUDE loader.f     \ Boot sector - loads "kernel" at $10000

  $10000 ORG
  INCLUDE init.f   \ Initialization code (prepare for P-mode)






  USE32 DECIMAL
  ."    32-bit code begins at " $.
  ." To dissassemble:" cr
  ." ndisasm -u -e 1024 -k 0," $' 1024 - . ." image | less" cr

\ ** Word definitions
  INCLUDE meta.f     \ Metacompiler
  INCLUDE prim.f     \ FORTH primitives
  INCLUDE display.f  \ PC video (text mode)
  INCLUDE keyboard.f \ Keyboard
  INCLUDE floppy.f   \ Floppy drive
\ INCLUDE ide.f      \ IDE hard drive
  INCLUDE forth.f    \ Higher-level FORTH

\ ** Wrap everything up...
  INCLUDE final.f    \ Finalization & startup code
