\ Text file to blockfile converter
\
\ Usage:  FILE>BLK filename.f
\ Output: filename.fb
\
\ 1. Run this program
\ 2. If any lines were too long, fix them and run it again
\ 3. In a block editor, move things around so they fit nice
\
\ I'd suggest you use the blockfile as your master, and convert
\ to text files if you need them - it's easier.

\ LIMITATIONS:
\    Doesn't expand tabs yet (in CONVERT-AND-WRITE)


( file-id's )
VARIABLE SRC
VARIABLE DST

VARIABLE LINE

\ TBD: Expand tabs
: CONVERT-AND-WRITE ( a u -  Pad to 64 and write)
  DUP 64 <  IF  2DUP +   64 ROT -  BLANK  ELSE  DROP  THEN
  ( a) 64 DST @ WRITE-FILE ABORT" Write error" ;

: BASENAME ( a1 u1 - a2 u2  Remove extension)
  SWAP OVER ( u a u)
  BEGIN 1- 2DUP + C@ [CHAR] . =  OVER 0=  OR UNTIL
  ?DUP IF  ROT DROP  ELSE  SWAP  THEN ;

: ADD-FB ( a u - a2 u2  Add .fb extension)
  BASENAME  SWAP OVER PAD SWAP CMOVE ( u) >R
  S" .fb" SWAP OVER ( u a u) PAD R@ + SWAP CMOVE
  R> + PAD SWAP ;

: FILE>BLK ( "textfile" -)  BL PARSE 2DUP
  R/O OPEN-FILE ABORT" Can't open input file" SRC !
  ADD-FB  ." Saving as: " 2DUP TYPE CR
  R/W CREATE-FILE ABORT" Can't create output file" DST !
  0 LINE !
  BEGIN
    1 LINE +!
    PAD 128 SRC @ READ-LINE ABORT" Read error" ( u f)
    ?DUP IF
      PAD ROT ( f a u)
      ( Warn if too long:)
      DUP 64 > IF  LINE ? 9 EMIT  OVER 64 TYPE CR
        ."  CUT--> "  OVER 64 + OVER 64 - TYPE CR  THEN
      CONVERT-AND-WRITE
    THEN
  0= UNTIL
  ( Pad to end of block & close out)
  17  LINE @ -  15 AND
  ?DUP IF  0 DO PAD 0 CONVERT-AND-WRITE  LOOP  THEN
  SRC @ CLOSE-FILE  DST @ CLOSE-FILE  2DROP ;
